    View Javadoc
    1   package org.apache.bcel.generic;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56  import org.apache.bcel.Constants;
    57  import org.apache.bcel.classfile.*;
    58  import java.util.StringTokenizer;
    59
    60  /***
    61   * Super class for the INVOKExxx family of instructions.
    62   *
    63   * @version $Id: InvokeInstruction.java,v 1.1.1.1 2001/10/29 20:00:20 jvanzyl Exp $
    64   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    65   */
    66  public abstract class InvokeInstruction extends FieldOrMethod
    67    implements ExceptionThrower, TypedInstruction, StackConsumer, StackProducer {
    68    /***
    69     * Empty constructor needed for the Class.newInstance() statement in
    70     * Instruction.readInstruction(). Not to be used otherwise.
    71     */
    72    InvokeInstruction() {}
    73
    74    /***
    75     * @param index to constant pool
    76     */
    77    protected InvokeInstruction(short opcode, int index) {
    78      super(opcode, index);
    79    }
    80
    81    /***
    82     * @return mnemonic for instruction with symbolic references resolved
    83     */
    84    public String toString(ConstantPool cp) {
    85      Constant        c   = cp.getConstant(index);
    86      StringTokenizer tok = new StringTokenizer(cp.constantToString(c));
    87
    88      return Constants.OPCODE_NAMES[opcode] + " " +
    89        tok.nextToken().replace('.', '/') + tok.nextToken();
    90    }
    91
    92    /***
    93     * Also works for instructions whose stack effect depends on the
    94     * constant pool entry they reference.
    95     * @return Number of words consumed from stack by this instruction
    96     */
    97    public int consumeStack(ConstantPoolGen cpg) {
    98        String signature = getSignature(cpg);
    99        Type[] args      = Type.getArgumentTypes(signature);
    100       int    sum;
    101
    102       if(opcode == Constants.INVOKESTATIC)
    103 	sum = 0;
    104       else
    105 	sum = 1;  // this reference
    106
    107       int n = args.length;
    108       for (int i = 0; i < n; i++)
    109 	sum += args[i].getSize();
    110
    111       return sum;
    112    }
    113
    114   /***
    115    * Also works for instructions whose stack effect depends on the
    116    * constant pool entry they reference.
    117    * @return Number of words produced onto stack by this instruction
    118    */
    119   public int produceStack(ConstantPoolGen cpg) {
    120     return getReturnType(cpg).getSize();
    121   }
    122
    123   /*** @return return type of referenced method.
    124    */
    125   public Type getType(ConstantPoolGen cpg) {
    126     return getReturnType(cpg);
    127   }
    128
    129   /*** @return name of referenced method.
    130    */
    131   public String getMethodName(ConstantPoolGen cpg) {
    132     return getName(cpg);
    133   }
    134
    135   /*** @return return type of referenced method.
    136    */
    137   public Type getReturnType(ConstantPoolGen cpg) {
    138     return Type.getReturnType(getSignature(cpg));
    139   }
    140
    141   /*** @return argument types of referenced method.
    142    */
    143   public Type[] getArgumentTypes(ConstantPoolGen cpg) {
    144     return Type.getArgumentTypes(getSignature(cpg));
    145   }
    146 }

This page was automatically generated by Maven